// YUSBHid.h: CYUSBHid NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_YUSBHID_H__FC7021BD_97A1_4CFC_BB2B_7462EA38EE06__INCLUDED_)
#define AFX_YUSBHID_H__FC7021BD_97A1_4CFC_BB2B_7462EA38EE06__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <setupapi.h>
#pragma comment(lib, "setupapi.lib")

class CYUSBHid  
{
public:
	int GetInput(char* buffer, int len);
	int SendOutput(char* buffer, int len);
	int OpenDevice(int vendorID, int productID, int useReportIDs, char* vendorName, char* productName);
	int CloseDevice();
	int SendReport(char* buffer, int len);
	int GetReport(char* buffer, int reportNumber, int len);
	BOOL DeviceIsOpen();
	CYUSBHid();
	virtual ~CYUSBHid();
private:
	void ConvUniToAscii(char* buffer);
	struct HIDD_ATTRIBUTES {
		ULONG   Size;
		USHORT  VendorID;
		USHORT  ProductID;
		USHORT  VersionNumber;
	};

	typedef BOOL __stdcall HIDD_GETHIDGUID(GUID *pGuid);
	HIDD_GETHIDGUID *HidD_GetHidGuid;

	typedef BOOL __stdcall HIDD_GETATTRIBUTES(HANDLE HidDeviceObject, HIDD_ATTRIBUTES* Attributes);
	HIDD_GETATTRIBUTES *HidD_GetAttributes;
	
	typedef BOOL __stdcall HIDD_GETFEATURE(HANDLE HidDeviceObject, PVOID ReportBuffer, ULONG ReportBufferLength);
	HIDD_GETFEATURE *HidD_GetFeature;
	
	typedef BOOL __stdcall HIDD_SETFEATURE(HANDLE HidDeviceObject, PVOID ReportBuffer, ULONG ReportBufferLength);
	HIDD_SETFEATURE *HidD_SetFeature;

	typedef BOOL __stdcall HIDD_GETMANUFACTURERSTRING(HANDLE HidDeviceObject, PVOID Buffer, ULONG BufferLength);
	HIDD_GETMANUFACTURERSTRING* HidD_GetManufacturerString;
	
	typedef BOOL __stdcall HIDD_GETPRODUCTSTRING(HANDLE HidDeviceObject, PVOID Buffer, ULONG BufferLength);
	HIDD_GETPRODUCTSTRING* HidD_GetProductString;


	HMODULE m_hModule; // DLL ̃nh
	HANDLE  m_hDevice; // USB foCX̃nh

	HANDLE m_hRead, m_hWrite; // 
};

#endif // !defined(AFX_YUSBHID_H__FC7021BD_97A1_4CFC_BB2B_7462EA38EE06__INCLUDED_)
